Create Department humanresources.node.add

If you are developing integrations for Bitrix24 using AI tools (Codex, Claude Code, Cursor), connect to the MCP server so that the assistant can utilize the official REST documentation.

Scope: humanresources

Who can execute the method: a user with the "Add new departments" or "Add new teams" permission.

The method humanresources.node.add creates a new department or team.

Method Parameters

Required parameters are marked with *

Name
type

Description

type*
string

The type of the structure element being created.

Possible values:

  • DEPARTMENT — department
  • TEAM — team

name*
string

The name of the department or team

parentId*
integer

The identifier of the parent department or team.

The identifier can be obtained using the humanresources.node.list method.

description
string

Description of the department or team

colorName
string

The color of the team.

Possible values:

  • blue — blue
  • green — green
  • cyan — cyan
  • orange — orange
  • purple — purple
  • pink — pink

userIds
object

Users to be added to the department or team. Description of the object structure

User identifiers can be obtained using the user.get method.

moveUsersToNode
boolean

Determines whether to transfer users from userIds to the new department.

Possible values:

  • true — users will be removed from the previous department and moved to the new department
  • false — users will only be added to the new department

Default: false

Use if type is DEPARTMENT.

createChat
boolean

Determines whether to create a new chat for the department.

Possible values:

  • true — create a chat
  • false — do not create a chat

Default: false

bindingChatIds
array

An array of identifiers of existing chats to be linked to the department.

Chat identifiers can be obtained using the im.recent.list method.

createChannel
boolean

Determines whether to create a new channel for the department.

Possible values:

  • true — create a channel
  • false — do not create a channel

Default: false

bindingChannelIds
array

An array of identifiers of existing channels to be linked to the department.

Channel identifiers can be obtained using the im.recent.list method.

createCollab
boolean

Determines whether to create a new collaboration for the department if collaborations are available in the plan.

Possible values:

  • true — create a collaboration
  • false — do not create a collaboration

Default: false

bindingCollabIds
array

An array of identifiers of existing collaborations to be linked to the department.

Collaboration identifiers can be obtained using the socialnetwork.api.workgroup.list method.

settings
object

Additional settings for the department or team. Description of the object structure

Parameter userIds

Name
type

Description

MEMBER_HEAD
array

Identifiers of department heads

MEMBER_DEPUTY_HEAD
array

Identifiers of deputy heads of the department

MEMBER_EMPLOYEE
array

Identifiers of department employees

MEMBER_TEAM_HEAD
array

Identifiers of team leaders

MEMBER_TEAM_DEPUTY_HEAD
array

Identifiers of deputy team leaders

MEMBER_TEAM_EMPLOYEE
array

Identifiers of team members

Parameter settings

Name
type

Description

BUSINESS_PROC_AUTHORITY
array

Roles allowed to work with the department or team workflows.

Possible values:

  • HEAD — department head
  • DEPUTY_HEAD — deputy department head
  • ALL_DEPARTMENT_HEADS — all department heads
  • EMPLOYEE — department employee
  • TEAM_HEAD — team leader
  • TEAM_DEPUTY — deputy team leader
  • TEAM_EMPLOYEE — team member

REPORTS_AUTHORITY
array

Roles allowed to work with the department or team reports.

Possible values:

  • HEAD — department head
  • DEPUTY_HEAD — deputy department head
  • ALL_DEPARTMENT_HEADS — all department heads
  • EMPLOYEE — department employee
  • TEAM_HEAD — team leader
  • TEAM_DEPUTY — deputy team leader
  • TEAM_EMPLOYEE — team member

Code Examples

How to Use Examples in Documentation

The call to the new API differs by the addition of the /api/ parameter in the request:

https://{installation_address}/rest/api/{user_id}/{webhook_token}/humanresources.node.add

curl -X POST \
        -H "Content-Type: application/json" \
        -H "Accept: application/json" \
        -d '{"type":"DEPARTMENT","name":"Marketing Department","parentId":1,"description":"Responsible for promotion","userIds":{"MEMBER_HEAD":[7],"MEMBER_EMPLOYEE":[12,15]},"moveUsersToNode":true,"createChat":true,"bindingChatIds":[31],"createChannel":false,"createCollab":false,"settings":{"BUSINESS_PROC_AUTHORITY":["HEAD","DEPUTY_HEAD"],"REPORTS_AUTHORITY":["HEAD"]}}' \
        https://**put_your_bitrix24_address**/rest/api/**put_your_user_id_here**/**put_your_webhook_here**/humanresources.node.add
        
curl -X POST \
        -H "Content-Type: application/json" \
        -H "Accept: application/json" \
        -d '{"type":"DEPARTMENT","name":"Marketing Department","parentId":1,"description":"Responsible for promotion","userIds":{"MEMBER_HEAD":[7],"MEMBER_EMPLOYEE":[12,15]},"moveUsersToNode":true,"createChat":true,"bindingChatIds":[31],"createChannel":false,"createCollab":false,"settings":{"BUSINESS_PROC_AUTHORITY":["HEAD","DEPUTY_HEAD"],"REPORTS_AUTHORITY":["HEAD"]},"auth":"**put_access_token_here**"}' \
        https://**put_your_bitrix24_address**/rest/api/humanresources.node.add
        

The SDK does not yet support the /rest/api/ address in calls. Use direct HTTP requests, for example, via curl or fetch.

try
        {
            const response = await $b24.callMethod(
                'humanresources.node.add',
                {
                    type: 'DEPARTMENT',
                    name: 'Marketing Department',
                    parentId: 1,
                    description: 'Responsible for promotion',
                    userIds: {
                        MEMBER_HEAD: [7],
                        MEMBER_EMPLOYEE: [12, 15]
                    },
                    moveUsersToNode: true,
                    createChat: true,
                    bindingChatIds: [31],
                    settings: {
                        BUSINESS_PROC_AUTHORITY: ['HEAD', 'DEPUTY_HEAD'],
                        REPORTS_AUTHORITY: ['HEAD']
                    }
                }
            );
        
            const result = response.getData().result;
            console.info('Department created with ID', result.id);
        }
        catch (error)
        {
            console.error(error);
        }
        

The SDK does not yet support the /rest/api/ address in calls. Use direct HTTP requests, for example, via curl or fetch.

try {
            $response = $b24Service
                ->core
                ->call(
                    'humanresources.node.add',
                    [
                        'type' => 'DEPARTMENT',
                        'name' => 'Marketing Department',
                        'parentId' => 1,
                        'description' => 'Responsible for promotion',
                        'userIds' => [
                            'MEMBER_HEAD' => [7],
                            'MEMBER_EMPLOYEE' => [12, 15],
                        ],
                        'moveUsersToNode' => true,
                        'createChat' => true,
                        'bindingChatIds' => [31],
                        'settings' => [
                            'BUSINESS_PROC_AUTHORITY' => ['HEAD', 'DEPUTY_HEAD'],
                            'REPORTS_AUTHORITY' => ['HEAD'],
                        ],
                    ]
                );
        
            $result = $response
                ->getResponseData()
                ->getResult();
        
            echo 'Success: ' . print_r($result, true);
        
        } catch (Throwable $e) {
            error_log($e->getMessage());
            echo 'Error creating department: ' . $e->getMessage();
        }
        

The SDK does not yet support the /rest/api/ address in calls. Use direct HTTP requests, for example, via curl or fetch.

BX24.callMethod(
            'humanresources.node.add',
            {
                type: 'DEPARTMENT',
                name: 'Marketing Department',
                parentId: 1,
                description: 'Responsible for promotion',
                userIds: {
                    MEMBER_HEAD: [7],
                    MEMBER_EMPLOYEE: [12, 15]
                },
                moveUsersToNode: true,
                createChat: true,
                bindingChatIds: [31],
                settings: {
                    BUSINESS_PROC_AUTHORITY: ['HEAD', 'DEPUTY_HEAD'],
                    REPORTS_AUTHORITY: ['HEAD']
                }
            },
            function(result){
                console.info(result.data());
                console.log(result);
            }
        );
        

The SDK does not yet support the /rest/api/ address in calls. Use direct HTTP requests, for example, via curl or fetch.

require_once('crest.php');
        
        $result = CRest::call(
            'humanresources.node.add',
            [
                'type' => 'DEPARTMENT',
                'name' => 'Marketing Department',
                'parentId' => 1,
                'description' => 'Responsible for promotion',
                'userIds' => [
                    'MEMBER_HEAD' => [7],
                    'MEMBER_EMPLOYEE' => [12, 15]
                ],
                'moveUsersToNode' => true,
                'createChat' => true,
                'bindingChatIds' => [31],
                'settings' => [
                    'BUSINESS_PROC_AUTHORITY' => ['HEAD', 'DEPUTY_HEAD'],
                    'REPORTS_AUTHORITY' => ['HEAD']
                ]
            ]
        );
        
        echo '<PRE>';
        print_r($result);
        echo '</PRE>';
        

Response Handling

HTTP Status: 200

{
            "result": {
                "id": 44,
                "name": "Marketing Department",
                "type": "DEPARTMENT",
                "structureId": 1,
                "parentId": 1,
                "description": "Responsible for promotion",
                "accessCode": "DR44",
                "userCount": 3,
                "colorName": null,
                "xmlId": null,
                "createdAt": "2026-06-02T11:15:20+02:00",
                "updatedAt": "2026-06-02T11:15:20+02:00",
                "members": [
                    {
                        "userId": 7,
                        "name": "Anna Smith",
                        "workPosition": "Head of Marketing Department",
                        "role": "MEMBER_HEAD",
                        "avatar": "https://example.bitrix24.com/upload/main/1/avatar.jpg",
                        "url": "/company/personal/user/7/"
                    },
                    {
                        "userId": 12,
                        "name": "John Doe",
                        "workPosition": "Marketer",
                        "role": "MEMBER_EMPLOYEE",
                        "avatar": null,
                        "url": "/company/personal/user/12/"
                    }
                ]
            },
            "time": {
                "start": 1780388120,
                "finish": 1780388120.645321,
                "duration": 0.6453211307525635,
                "processing": 0.6032140254974365,
                "date_start": "2026-06-02T11:15:20+02:00",
                "date_finish": "2026-06-02T11:15:20+02:00",
                "operating_reset_at": 1780388720,
                "operating": 0
            }
        }
        

Returned Data

Name
type

Description

result
object

Object containing data of the created structure element

id
integer

Identifier of the created department or team

name
string

Name of the department or team

type
string

Type of the structure element

structureId
integer

Identifier of the company structure

parentId
integer

Identifier of the parent department or team

description
string

Description of the department or team

accessCode
string

Access code of the structure element

userCount
integer

Number of users in the department or team

colorName
string

Team color, if specified

xmlId
string

External identifier of the structure element

createdAt
datetime

Date and time of creation of the structure element

updatedAt
datetime

Date and time of the last update of the structure element

members
array

List of users added to the department or team with roles

members[]
object

User object of the department or team

userId
integer

User identifier

name
string

User name

workPosition
string

User position

role
string

User role in the department or team

avatar
string

Link to the user's avatar

url
string

Link to the user's profile

time
time

Information about the request execution time

Error Handling

HTTP Status: 400

{
            "error": {
                "code": "BITRIX_REST_V3_EXCEPTION_VALIDATION_REQUESTVALIDATIONEXCEPTION",
                "message": "Error validating the request object",
                "validation": [
                    {
                        "message": "Required field `name` is not specified",
                        "field": "name"
                    }
                ]
            }
        }
        

Name
type

Description

error.code
string

String error code. Use it to identify the type of exception

error.message
string

Text description of the error

error.validation
array

Array with error details. Present only in data validation errors BITRIX_REST_V3_EXCEPTION_VALIDATION_REQUESTVALIDATIONEXCEPTION

error.validation[].field
string

Name of the field where the validation error occurred

error.validation[].message
string

Description of the error related to the specified field

Possible Error Codes

Request Validation Errors

Error Code: BITRIX_REST_V3_EXCEPTION_VALIDATION_REQUESTVALIDATIONEXCEPTION

Field

Error Description

How to Fix

type
name
parentId

Required field #FIELD# is not specified

Add the specified field to the request body

#FIELD#

Field #FIELD# requires data type #TYPE# for this request

Ensure the value passed is of the correct type

type

An invalid value for the structure element type was provided

Use DEPARTMENT for a department or TEAM for a team

-

Default company structure not found

Ensure the company structure is created and accessible

Access Errors

Error Code: BITRIX_REST_V3_EXCEPTION_ACCESSDENIEDEXCEPTION

Field

Error Description

How to Fix

-

Access denied

The user does not have permission to create a structure element in the specified parent department or team

Error Code: BITRIX_REST_V3_EXCEPTION_INSUFFICIENTSCOPEEXCEPTION

Field

Error Description

How to Fix

-

Insufficient permissions: required scope is missing

Check the humanresources scope

Statuses and System Error Codes

HTTP Status: 20x, 40x, 50x

The errors described below may occur when calling any method.

Status

Code
Error Message

Description

500

INTERNAL_SERVER_ERROR
Internal server error

An internal server error has occurred. Please contact the server administrator or Bitrix24 technical support

500

ERROR_UNEXPECTED_ANSWER
Server returned an unexpected response

An internal server error has occurred. Please contact the server administrator or Bitrix24 technical support

503

QUERY_LIMIT_EXCEEDED
Too many requests

The request intensity limit has been exceeded

405

ERROR_BATCH_METHOD_NOT_ALLOWED
Method is not allowed for batch usage

The current method is not permitted for calls using batch

400

ERROR_BATCH_LENGTH_EXCEEDED
Max batch length exceeded

The maximum length of parameters passed to the batch method has been exceeded

401

NO_AUTH_FOUND
Wrong authorization data

Invalid access token or webhook code

400

INVALID_REQUEST
Https required

The HTTPS protocol is required for method calls

503

OVERLOAD_LIMIT
REST API is blocked due to overload

The REST API is blocked due to overload. This is a manual individual block; please contact Bitrix24 technical support to lift it

403

ACCESS_DENIED
REST API is available only on commercial plans

The REST API is only available on commercial plans

403

INVALID_CREDENTIALS
Invalid request credentials

The user associated with the access token or webhook used to call the method lacks the necessary permissions

404

ERROR_MANIFEST_IS_NOT_AVAILABLE
Manifest is not available

The manifest is not available

403

insufficient_scope
The request requires higher privileges than provided by the webhook token

The request requires higher privileges than those provided by the webhook token

401

expired_token
The access token provided has expired

The provided access token has expired

403

user_access_error
The user does not have access to the application

The user does not have access to the application. This means that the application is installed, but the portal administrator has restricted access to this application to specific users only

500

PORTAL_DELETED
Portal was deleted

The public part of the site is closed. To open the public part of the site on an on-premise installation, disable the "Temporary closure of the public part of the site" option. Path to the setting: Desktop > Settings > Product Settings > Module Settings > Main Module > Temporary closure of the public part of the site

Continue Learning